// Ispitivanje klasa za zbirke figura.

#include "red.h"
#include "stek3.h"
#include "krug2.h"
#include "kvadrat.h"
#include "trougao.h"
#include <iostream.h>

Figura *citaj () {                      // CITANJE FIGURE.
  cout << "Vrsta (o, k, t)? "; char vrsta; cin >> vrsta;
  Figura *pf = 0;
  switch (vrsta) {
    case 'o': case 'O': 
      pf = new Krug;    cout << "x, y, ro? ";      break;
    case 'k': case 'K':
      pf = new Kvadrat; cout << "x, y, a? ";       break;
    case 't': case 'T':
      pf = new Trougao; cout << "x, y, a, b, c? "; break;
  }
  if (pf) cin >> *pf;
  return pf;
}

int main (int bpar, char *vpar[]) {     // GLAVNI PROGRAM.
  int nred = 1, nstek = 1;              // Stvaranje praznih zbirki.
  if (bpar > 1) nred  = atoi (vpar[1]);
  if (bpar > 2) nstek = atoi (vpar[2]);
  Zbirka **zbe = new Zbirka * [nred + nstek];
  for (int i=0; i<nred+nstek; i++) 
    if (i<nred) zbe[i] = new Red; else zbe[i] = new Stek;
  int zb = 0;                           // Indeks tekuce zbirke.
  Figura *pf = 0;                       // Pokazivac na tekucu figuru.
  for (int dalje=1; dalje; ) {
    // Ispisivanje menija.
    cout << "\nMoguce operacije su:\n\n"
            "1 Biraj zbirku i prikazi       7 Prikazi prvu figuru\n"
            "2 Prikazi zbirku               8 Prikazi datu figuru\n"
            "3 Citaj figuru i stavi         9 Kopiraj zbirku\n"
            "4 Stavi figuru                 0 Dodaj zbirku\n"
            "5 Uzmi figuru i prikazi        p Prazni zbirku\n"
            "6 Prikazi figuru               k Zavrsi sa radom\n"
            "\nUnesite svoj izbor: ";
    char izb; cin >> izb;
    switch (izb) {
      // Biranje zbirke.
      case '1': cout << "Redni broj zbirke? "; int zzb; cin >> zzb;
                if (zzb<=0 && zzb>nred+nstek)
                  { cout << "*** Neispravan redni broj!\n\a"; break; }
                zb = zzb - 1;
      // Prikazivanje sadraja tekuce zbirke.
      case '2': cout << *zbe[zb];
                break;
      // Citanje figure.
      case '3': { Figura *ppf = citaj ();
                  if (! ppf)
                    { cout << "*** Neispravna vrsta!\n\a"; break; }
                  delete pf; pf = ppf;
                }
      // Stavljanje tekuce figure u tekucu zbirku.
      case '4': if (pf) *zbe[zb] += *pf->kopija ();
                  else  cout << "*** Nema figure!\n\a";
                break;
      // Uzimanje prve figure iz tekuce zbirke.
      case '5': if (!+*zbe[zb])
                  { cout << "*** Zbirka je prazna!\n\a"; break; }
                delete pf; pf = &--*zbe[zb];
      // Prikazivanje tekuce figure.
      case '6': if (pf) cout << "  " << *pf << endl;
                  else  cout << "*** Nema figure!\n\a";
                break;
      // Prikazivanje prve figure u tekucoj zbirki.
      case '7': if (+*zbe[zb]) cout << "  " << -*zbe[zb] << endl;
                  else cout << "*** Zbirka je prazna!\n\a";
                break;
      // Prikazivanje odabrane figure iz tekuce zbirke.
      case '8': cout << "Redni broj figure? "; int i; cin >> i;
                if (i>0 && i<=+*zbe[zb]) 
                  cout << "  " <<(*zbe[zb])[i] << endl;
                else cout << "*** Neispravan redni broj!\n\a";
                break;
      // Kopiranje tekuce zbirke u odabranu zbirku
      //   (stari sadrzaj odredisne zbirke se unisti).
      case '9': cout << "Broj odredisne zbirke? "; cin >> zzb;
                if (zzb>0 && zzb<=nred+nstek) {
                  delete zbe[zzb-1]; zbe[zzb-1] = zbe[zb]->kopija ();
                } else cout << "*** Neispravan redni broj!\n\a";
                break;
      // Dodavanje svih figura iz tekuce zbirke u odabranu zbirku
      //   (stari sadrzaj odredisne zbirke se sacuva).
      case '0': cout << "Broj odredisne zbirke? "; cin >> zzb;
                if (zzb>0 && zzb<=nred+nstek) { zzb--;
                  for (i=1; i<=+*zbe[zb]; *zbe[zzb]+=(*zbe[zb])[i++]);
                } else
                  cout << "*** Neispravan redni broj!\n\a";
                break;
      // Pranjenje tekuce zbirke.
      case 'p': case 'P': ~*zbe[zb]; break;
      // Zavrsetak rada.
      case 'k': case 'K': dalje = 0; break;
      // Poruka o neispravnom izboru.
      default : cout << "*** Neispravan izbor!\n\a";
    }
  }
  return 0;
}
